// CLASSE DI RIFERIMENTO
class ListaConcatenata {
	// METODI ATTRAVERSAMENTO ==============================
	
	// METODO ATTRAVERSAMENTO COME ARRAY
	public void Attraversamento (int[] info, int[] link) { 
		System.out.println("i info link");
		for (int i=0; i<info.length; i++) {
			System.out.println(i + " " + info[i] + "  " + link[i]);
		}
	} 
	
	// METODO ATTRAVERSAMENTO INFO COME LISTA CONCATENATA
	public void AttraversamentoI (int[] info, int[] link) {
		int START	= info[0];
		int DISP	= link[0];		// NON OCCORRE		
		int ptr 	= START;
		System.out.println("i info link");
		while(ptr != -1) {
			System.out.println(ptr + " " + info[ptr] + "  " + link[ptr]);
			ptr = link[ptr];
		}
	} 
  
	// METODO ATTRAVERSAMENTO DISP COME LISTA CONCATENATA
	public void AttraversamentoD (int[] info, int[] link) { 
		int START	= info[0];		// NON OCCORRE	
		int DISP 	= info[0];
		int ptr		= link[0];
		System.out.println("i info link");
		while(ptr != -1) {
			System.out.println(ptr + " " + info[ptr] + "    " + link[ptr]);
			ptr = link[ptr];
		}
	} 


	// METODI INSERIMENTO ITEM =============================
	
	// METODO INSERIMENTO ITEM IN START LISTA CONCATENATA
	static int InserimentoInSTART (int[] info, int[] link, int item) { 
		// Pre
		int START		= info[0];		
		int DISP 		= link[0];
		int risultato	= 0;	
		int NEWnodo		= 0;
		
		// Controllo esistenza nodi disponibili
		if (DISP == -1) { 
			// Nessuna disponibilita
			risultato = -1;
		}
		else {
			// Toglie il primo nodo da lista disponibili
			NEWnodo	= DISP; 
			DISP 	= link[DISP]; 
			
			// Copia il nuovo dato in nuovo nodo 
			info[NEWnodo] = item; 
			
			// Aggiorna i puntatori
				// Il nuovo nodo punta ora al primo
				link[NEWnodo] = START;
				
				// Cambia START in modo che punti al nuovo nodo
				START = NEWnodo;	
			
			// Aggiorna START e DISP
			info[0] = START;
			link[0] = DISP;
			// Visualizzazione solo per controllo
			System.out.println("Nuovo START = " + START);
			System.out.println("Nuovo DISP = "  + DISP);
			
			risultato = NEWnodo;
		}
		return risultato;
	} 

	// METODO INSERIMENTO ITEM IN LISTA CONCATENATA DOPO loc
	static int InserimentoDopoLoc (int[] info, int[] link, int item, int loc) { 
		// Pre
		int START		= info[0];		
		int DISP 		= link[0];
		int risultato	= 0;	
		int NEWnodo		= 0;
		
		// Controllo esistenza nodi disponibili
		if (DISP == -1) { 
			// Nessuna disponibilita
			risultato = -1;
		}
		else {
			// Toglie il primo nodo da lista disponibili
			NEWnodo	= DISP; 
			DISP = link[DISP]; 
			
			// Copia il nuovo dato in nuovo nodo 
			info[NEWnodo] = item; 

			//Inserisce dopo nodo con locazione loc. 
			// Aggiorna i puntatori
				// Il nuovo nodo punta ora al nodo puntato prima da loc
				link[NEWnodo] = link[loc];

				// Cambiamo in modo che loc ora punti al nuovo nodo
				link[loc] = NEWnodo;
			
			// Aggiorna START e DISP
			info[0] = START;
			link[0] = DISP;
			
			risultato 	= NEWnodo;
		}
		return risultato;
	} 
	

	// METODO ELIMINA ITEM DOPO LOC IN LISTA CONCATENATA
	static int EliminaDopoLoc (int[] info, int[] link, int loc) { 
		// Pre
		int START		= info[0];		
		int DISP 		= link[0];
		int risultato	= 0;	
		int ELInodo		= 0;

		if (loc == -1) {
			// Si tratta del primo nodo
			ELInodo = START;
			START = link[START];
			risultato = ELInodo;
		}	
		else {
			// Si tratta di nodo diverso dal primo
			// Aggiorna i puntatori
				// Il nodo da eliminare è quello a cui punta loc
				ELInodo = link[loc];
			
				// Cambiamo in modo che loc ora punti al link del nodo eliminato
				link[loc] = link[ELInodo];
				
			risultato = ELInodo;
		}
		
		//Rende il nodo DISP
		DISP = ELInodo;
		link[ELInodo] = DISP;
			
		// Aggiorna START e DISP
		info[0] = START;
		link[0] = DISP;
		
		return risultato;
	} 	

	
	// METODO RICERCA ITEM IN INFO COME LISTA CONCATENATA
	static int Ricerca (int[] info, int[] link, int item) { 
      int inizio 	  = info[0];		
      int disponibile = link[0];		
      int ptr = inizio;
	  int loc = 0;
      while(ptr != -1) {
			if (info[ptr] == item){ 
				// TROVATO
				loc = ptr;
				break;
			}				
			else {
				//PTR punta ora al nodo successivo				
				ptr = link[ptr];  
			}
      }
		return loc;
	} 
}	



public class Main{
	// ESERCIZIO CHE ISTANZIA LA CLASSE ListaConcatenata
	public static void main(String[] args) {
		// Istanza della classe ListaConcatenata
		ListaConcatenata Elenco = new ListaConcatenata(); 

		//Dichiaro le variabili necessarie iniziali 
		final int NMAX = 10;
		int[] info = new int[NMAX];
		int[] link = new int[NMAX];		
		int item;
		int risultato;
		int loc;
		
		//POPOLOAMENTO DI INFO E LINK fino a (DISP-1)
		int START = 1;
		int DISP = 6;
		info[0] = START;	// START lista dei nodi occupati
		link[0] = DISP;		// START lista dei nodi disponibili
		System.out.println("Popolamento nodi");
		int i;
		for(i=1; i<=info.length-(DISP-1); i++) {
			info[i] = i*100;
			link[i] = i+1;
		}
		// Identifico l'ultimo nodo con il fine lista -1
		link[info.length-(DISP-1)] = -1;
      
		//POPOLOAMENTO DI INFO E LINK da (DISP)
		for(i=DISP; i<info.length; i++) {
				info[i] = 0;
				link[i] = i+1;
		}
		// Identifico l'ultimo nodo con il fine lista -1
		link[info.length-1] = -1;
		System.out.println("");
		
		// RICHIAMO METODI
		System.out.println("Attraversamento come ARRAY");
		Elenco.Attraversamento (info, link);
 		System.out.println("");
     
		System.out.println("Attraversamento LISTA CONCATENATA");
		System.out.println("START = " + START);
		Elenco.AttraversamentoI (info, link);
		System.out.println("");
		
		System.out.println("Attraversamento LISTA DISP");
		System.out.println("DISP = " + DISP);
		Elenco.AttraversamentoD (info, link);
		System.out.println("");
	}
}



// OUTPUT
Popolamento nodi

Attraversamento come ARRAY
i info link
0 1  6
1 100  2
2 200  3
3 300  4
4 400  5
5 500  -1
6 0  7
7 0  8
8 0  9
9 0  -1

Attraversamento LISTA CONCATENATA
START = 1
i info link
1 100  2
2 200  3
3 300  4
4 400  5
5 500  -1

Attraversamento LISTA DISP
DISP = 6
i info link
6 0    7
7 0    8
8 0    9
9 0    -1